## xiphos 4.0.7.1

=== debian/changelog ===
xiphos (4.0.7.1-4) unstable; urgency=high

  * switch configure from webkitgtk to webkit2gtk
  * patch upstream source for webkit2

 -- Teus Benschop <teusjannette@gmail.com>  Sun, 28 Oct 2018 07:12:08 +0100

xiphos (4.0.7.1-3) unstable; urgency=high

  * no longer build-depend on libwebkitgtk-3.0-dev

 -- Teus Benschop <teusjannette@gmail.com>  Fri, 26 Oct 2018 20:24:50 +0200

xiphos (4.0.7.1-2) unstable; urgency=high

  [ Jeremy Bicha ]
  * Add build-without-scrollkeeper.patch
  * Drop obsolete Build-Depends on rarian-compat

 -- Teus Benschop <teusjannette@gmail.com>  Thu, 25 Oct 2018 11:25:12 +0200

xiphos (4.0.7.1-1) unstable; urgency=high

  * debian/control: Updated Build-Depends

 -- Teus Benschop <teusjannette@gmail.com>  Tue, 09 Oct 2018 19:33:51 +0200

xiphos (4.0.7+dfsg1-3) unstable; urgency=medium

  * debian/control: Updated maintainer email: Closes: #899795
  * debian/control: Updated Vcs-* for Salsa

 -- Teus Benschop <teusjannette@gmail.com>  Fri, 05 Oct 2018 20:19:10 +0200

xiphos (4.0.7+dfsg1-2) unstable; urgency=low

  * new upstream release
  * d/control: add uploader
  * d/control: update build dependencies
  * d/source/lintian-overrides: add override
  * d/control: update standards version
  * d/debian/xiphos.lintian-overrides: add override

 -- Teus Benschop <teusjannette@gmail.com>  Fri, 27 Oct 2017 12:00:00 +0200

=== debian/control ===
Source: xiphos
Section: gnome
Priority: optional
Maintainer: CrossWire Packaging Team <pkg-crosswire-devel@alioth-lists.debian.net>
Uploaders: Daniel Glassey <wdg@debian.org>,
           Dimitri John Ledkov <xnox@debian.org>,
           Dominique Corbex <dominique@corbex.org>,
           Jonathan Marsden <jmarsden@fastmail.fm>,
           Unit 193 <unit193@ubuntu.com>,
           Teus Benschop <teusjannette@gmail.com>
Build-Depends: debhelper (>= 10),
               xsltproc,
               gnome-doc-utils,
               intltool,
               libbiblesync-dev,
               libdbus-glib-1-dev,
               libgconf2-dev,
               libgsf-1-dev,
               libgtk-3-dev,
               libsword-dev (>= 1.7.3),
               libwebkit2gtk-4.0-dev,
               libxml2-dev,
               uuid-dev
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/pkg-crosswire-team/xiphos
Vcs-Git: https://salsa.debian.org/pkg-crosswire-team/xiphos.git
Homepage: http://xiphos.org

Package: xiphos
Architecture: any
Depends: xiphos-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: xiphos-data (<< 4.0.5+dfsg1-1~)
Replaces: xiphos-data (<< 4.0.5+dfsg1-1~)
Conflicts: xiphos-svn
Provides: sword-frontend
Suggests: sword-text
Description: environment for Bible reading, study, and research
 Xiphos is a Bible study program for the GNOME desktop environment, based on The
 SWORD Project by the CrossWire Bible Society, a framework for developing Bible
 study tools and of associated texts such as commentaries and dictionaries.
 .
 This package provides the main Xiphos program, a digital text reader with
 bookmarks and full-text search. It allows viewing multiple versions of the same
 text, for parallel reading of alternatives or translations. It also supports
 personal verse-specific notes and a rich-text study pad, both of which have
 spell checking and full-text search.
 .
 Xiphos has a built-in facility to browse and install freely-distributed content
 from CrossWire repositories.

Package: xiphos-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: xiphos-svn
Suggests: xiphos
Description: data files for Xiphos Bible study software
 Xiphos is a Bible study program for the GNOME desktop environment, based on The
 SWORD Project by the CrossWire Bible Society, a framework for developing Bible
 study tools and of associated texts such as commentaries and dictionaries.
 .
 This package contains the data files that are necessary to use Xiphos.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
# Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	./waf configure --nocache --prefix=/usr --enable-webkit-editor --gtk=3 --debug-level=release --enable-webkit2

override_dh_auto_build:
	./waf build --nocache --verbose

override_dh_auto_install:
	./waf install --nocache --destdir=debian/tmp

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_missing:
	dh_missing --list-missing

override_dh_strip:
	dh_strip --dbgsym-migration='xiphos-dbg (<< 4.0.5+dfsg1-1~)'

override_dh_auto_clean:
	./waf distclean --nocache

override_dh_clean:
	find . -name '*.pyc' -delete
	rm -f 'src/examples/ipc-interface.xml'
	dh_clean

## xiphos 4.1.0+dfsg

=== debian/changelog ===
xiphos (4.1.0+dfsg-1build1) disco; urgency=medium

  * No-change rebuild for icu soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 13 Nov 2018 08:04:54 +0000

xiphos (4.1.0+dfsg-1) experimental; urgency=high

  [ Teus Benschop ]
  * d/control: depends on libsword 1.8.1-6 or higher
  * d/patches: update applied patches
  * d/patches: disable webkit editor again

  [ Daniel Glassey ]
  * d/compat,control: update to debhelper 11
  * fix repack-waf for unstable

  [ Teus Benschop ]
  * d/watch d/dfsg.sh:fix dfsg creator
  * New upstream version 4.1.0+dfsg

 -- Teus Benschop <teusjannette@gmail.com>  Fri, 09 Nov 2018 20:00:24 +0100

xiphos (4.0.7.1-5) unstable; urgency=high

  * dh_missing fail on missing: more robust
  * list source files not packaged

 -- Teus Benschop <teusjannette@gmail.com>  Fri, 02 Nov 2018 14:20:31 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
            Jonathan Marsden <jmarsden@fastmail.fm>,
            Unit 193 <unit193@ubuntu.com>,
            Teus Benschop <teusjannette@gmail.com>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
                xsltproc,
                gnome-doc-utils,
                intltool,
@@ -17,7 +17,7 @@
                libgconf2-dev,
                libgsf-1-dev,
                libgtk-3-dev,
-               libsword-dev (>= 1.7.3),
+               libsword-dev (>= 1.8.1-6),
                libwebkit2gtk-4.0-dev,
                libxml2-dev,
                uuid-dev

=== debian/watch ===
version=3
# No repacksuffix is specified because it's handled by debian/repack-waf.
# See <https://wiki.debian.org/UnpackWaf>.
opts=dversionmangle=s/\+dfsg\d+$// \
https://github.com/crosswire/xiphos/releases/ .*/xiphos-([\d\.]+)(?:-[\d]+)?\.tar\.gz debian debian/dfsg.sh

## xiphos 4.1.0+dfsg1

=== debian/changelog ===
xiphos (4.1.0+dfsg1-1) unstable; urgency=medium

  [ Teus Benschop ]
  * restore repack-waf fixed by Daniel

  [ Daniel Glassey ]
  * should run on testing once it gets in, Closes: #913070
  * d/control: build depend on libsword 1.8.1+dfsg-8
  * regenerate dfsg1 source using repack-waf and import

 -- Daniel Glassey <wdg@debian.org>  Tue, 13 Nov 2018 10:31:54 +0700

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
                libgconf2-dev,
                libgsf-1-dev,
                libgtk-3-dev,
-               libsword-dev (>= 1.8.1-6),
+               libsword-dev (>= 1.8.1+dfsg-8),
                libwebkit2gtk-4.0-dev,
                libxml2-dev,
                uuid-dev

## xiphos 4.1.0.1+dfsg1

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

import os, os.path
import intltool
import string
import Utils
import Options
import ccroot
import preproc
preproc.go_absolute=1
preproc.strict_quotes=0

import waffles.misc
import waffles.gnome as gnome

VERSION='4.1.0'

APPNAME='xiphos'
PACKAGE='xiphos'
srcdir = '.'
blddir = 'build'

_tooldir = './waffles/'
ROOTDIR_WIN32 = 'C:\msys'
_headers = '''
dlfcn.h
inttypes.h
locale.h
memory.h
stdint.h
stdlib.h
strings.h
string.h
sys/stat.h
sys/types.h
unistd.h
sys/select.h
sys/socket.h
winsock.h
'''.split()
def set_options(opt):

    opt.tool_options('g++ gcc')

    maingroup = opt.add_option_group('Main Xiphos Options')

    maingroup.add_option('--gtk',
                   action='store', default='auto', dest='gtkver',
                   choices=['auto', '3', '2'],
                   help="Select gtk+ API ['auto', '3', '2']")

    miscgroup = opt.add_option_group('Miscellaneous Options')

    miscgroup.add_option('-d', '--debug-level',
                action = 'store',
		default = ccroot.DEBUG_LEVELS.ULTRADEBUG,
		help = "Specify the debugging level ['ultradebug', 'debug', 'release', 'optimized']",
		choices = ['ultradebug', 'debug', 'release', 'optimized'],
		dest = 'debug_level')

    miscgroup.add_option('--strip', action='store_true', default=False,
                    help='Strip resulting binary')

    miscgroup.add_option('--enable-delint', action='store_true', default=False,
            dest='delint',
            help='Use -Wall -Werror [default: disabled]')

    miscgroup.add_option('--chatty', action='store_true', default=False,
            dest='chatty',
            help='Enable lots of tracing [default: disabled]')

    miscgroup.add_option('--enable-webkit-editor', action='store_true', default=False,
            dest='webkit_editor',
            help='Use webkit editor [default: disabled]')

    miscgroup.add_option('--enable-webkit2', action='store_true', default=False,
            dest='webkit2',
            help='Use webkit2 instead of original webkit [default: disabled]')

    miscgroup.add_option('--disable-dbus',
                   action = 'store_true',
                   default = False,
                   help = "Disable the Xiphos dbus API [default: enabled]",
                   dest = 'without_dbus')

    ### cross compilation from Linux/Unix for win32

    w32 = opt.add_option_group ('Windows and Cross-compile Options', '')

    w32.add_option('--target-platform-win32', action='store_true', default=False,
            dest='cross_win32',
            help='Cross-compile for win32 [default: disabled]')

    w32.add_option('--disable-console',
            action='store_true',
            default=False,
            help='Disable console window in win32 [default: enabled]',
            dest='no_console')

    w32.add_option('--pkgconf-libdir',
		action = 'store',
		default = os.path.join(ROOTDIR_WIN32, 'local', 'lib', 'pkgconfig'),
		help = "Specify dir with *.pc files for cross-compilation",
		dest = 'pkg_conf_libdir')

    w32.add_option('--pkgconf-prefix',
		action = 'store',
		default = os.path.join(ROOTDIR_WIN32, 'local'),
		help = "Specify prefix with folders for headers and libraries for cross-compilation",
		dest = 'pkg_conf_prefix')

    ######### end of windows options.

    group = opt.add_option_group ('Localization and documentation')
    group.add_option('--helpdir',
                     action = 'store',
                     default = '${DATAROOTDIR}/gnome/help/${PACKAGE}',
                     help = "user documentation [default: ${DATAROOTDIR}/gnome/help/${PACKAGE}]",
                     dest = 'helpdir')
    group.add_option('--disable-help',
                     action='store_true',
                    default=False,
                     help='Disable creating help files',
                     dest='disable_help')
    group.add_option('--no-post-install',
                   action = 'store_false',
                   default = True,
                   help = "Disable post-install tasks",
                   dest = 'post_install')

def configure(conf):

    opt = Options.options
    dfn = conf.define
    env = conf.env

    platform = Utils.detect_platform()
    env['IS_WIN32'] = platform == 'win32'
    env['IS_LINUX'] = platform == 'linux'

    env['IS_CROSS_WIN32'] = Options.options.cross_win32

    # cross-compilation for Windows
    # behave mostly like on windows platform
    if env['IS_CROSS_WIN32']:
        env['IS_WIN32'] = True
        env['IS_LINUX'] = False
        Utils.pprint('CYAN', "Cross-compilation")
        env['CROSS'] = os.environ['CROSS']

    # IS_WIN32 means compiling for win32, not necessarily compiling on win32
    if env['IS_WIN32']:
        Utils.pprint('CYAN', "Windows detected")
    elif env['IS_LINUX']:
        Utils.pprint('CYAN', "Linux detected")

    if not (env['IS_LINUX'] or env['IS_WIN32']):
        Utils.pprint('RED', "Assuming %s is UNIX like platform" % platform)
        env['IS_LINUX'] = True

    if env['IS_WIN32']:
        env['ROOTDIR'] = ROOTDIR_WIN32

    conf.check_tool('nothreads', tooldir=_tooldir)
    conf.check_tool('g++ gcc')
    # cross compiler
    if env['IS_CROSS_WIN32']:
        conf.check_tool('cross_linux_win32', tooldir=_tooldir)
  
    conf.check_tool('gnu_dirs misc')
    conf.check_tool('intltool')

    env['DISABLE_HELP'] = opt.disable_help

    if not opt.disable_help:
        if env['IS_LINUX']:
            conf.check_tool('gnome', tooldir=_tooldir)
        else:
            conf.check_tool('documentation', tooldir=_tooldir) # stuff to create help files

    # DATADIR is defined by intltool in config.h - conflict in win32 (mingw)
    conf.undefine('DATADIR')

    env['POST_INSTALL']=opt.post_install

    # delint flags
    env['CXXFLAGS_DELINT'] = ['-Werror', '-Wall']
    env['CCFLAGS_DELINT'] = ['-Werror', '-Wall', '-Wmissing-prototypes',
                             '-Wnested-externs', '-Wpointer-arith', '-Wno-sign-compare']

    # gcc compiler debug levels
    # msvc has levels predefined
    if env['CC_NAME'] == 'gcc':
        env['CCFLAGS_SAFE']       = env['CCFLAGS']
        env['CCFLAGS']            = []
        env['CCFLAGS_OPTIMIZED']  = ['-O2']
        env['CCFLAGS_RELEASE']    = ['-O2']
        env['CCFLAGS_DEBUG']      = ['-g', '-DDEBUG']
        env['CCFLAGS_ULTRADEBUG'] = ['-g3', '-O0', '-DDEBUG']

    if env['CXX_NAME'] == 'gcc':
        env['CXXFLAGS_SAFE']       = env['CXXFLAGS']
        env['CXXFLAGS']            = []
        env['CXXFLAGS_OPTIMIZED']  = ['-O2']
        env['CXXFLAGS_RELEASE']    = ['-O2']
        env['CXXFLAGS_DEBUG']      = ['-g', '-DDEBUG']
        env['CXXFLAGS_ULTRADEBUG'] = ['-g3', '-O0', '-DDEBUG']
    
    if env['IS_WIN32']:
        ## setup for Winsock on Windows (required for read-aloud)
        conf.check(lib='ws2_32', uselib='WSOCK', mandatory=True)
        conf.check(lib='shell32', uselib='SHELLAPI', mandatory=True)
        conf.check(lib='rpcrt4', uselib='RPCRT4', mandatory=True)
        # this isn't supposed to be necessary
        env['LINKFLAGS'] = ['-lws2_32', '-lrpcrt4']
        dfn('WIN32', 1)
        # tool to link icon with executable
        # use tool modified for cross-compilation support
        env['POST_INSTALL']=False
        conf.check_tool('winres', tooldir=_tooldir)
        # the following line does not work because of a problem with waf
        # conf.check_tool('intltool')
        #env['POCOM'] = conf.find_program('msgfmt')
        #env['INTLTOOL'] = '/usr/local/bin/intltool-merge'
    
    if env['IS_CROSS_WIN32']:
        # allows to use linux pkg-config for cross-compilation
        os.environ['PKG_CONFIG_PATH'] = opt.pkg_conf_libdir
        env['PKG_CONFIG_PREFIX'] = opt.pkg_conf_prefix

    # Auto detecting gtk version, if none were specified.
    if opt.gtkver == 'auto':
        if conf.check_cfg(modversion="gtk+-3.0", okmsg='ok',
                          msg='Auto detecting gtk 3'):
            opt.gtkver = '3'
        else:
            conf.check_cfg(modversion="gtk+-2.0", okmsg='ok',
                           msg='Auto detecting gtk 2', mandatory=True)
            opt.gtkver = '2'

    # FIXME: Find out why we still need this!
    dfn('WEBKIT', 1) 
    
    #gtk
    if opt.gtkver == '2':
        env['ENABLE_GTK2'] = True
        dfn('GTK2', 1)

    # disable console window in win32
    if opt.no_console and env['IS_WIN32']:
        env.append_value('LINKFLAGS', '-mwindows')

    # strip xiphos binary
    if env['IS_CROSS_WIN32']:
        env['STRIP'] = conf.find_program(env['CROSS'] + 'strip', mandatory=True)
    else:
        env['STRIP'] = conf.find_program('strip', mandatory=True)

    if (not env['IS_LINUX']) and (opt.debug_level in ['release','optimized']):
        env['TO_STRIP'] = True
    else:
        env['TO_STRIP'] = opt.strip

    if not opt.without_dbus:
        conf.check_pkg('dbus-glib-1', '0.60', True, var='DBUS')
        # we need a modified version of dbus.py for running on windows
        conf.check_tool('dbus', tooldir=_tooldir)
    
    conf.check_tool('glib2')

    ### App info, paths
    define = conf.define
    sub = Utils.subst_vars

    env['VERSION'] = VERSION
    env['APPNAME'] = APPNAME
    env['PACKAGE'] = PACKAGE
    env['HELPDIR'] = sub(opt.helpdir, env)

    define('VERSION', VERSION)
    define('PACKAGE_VERSION', VERSION)
    define('GETTEXT_PACKAGE', PACKAGE)
    define('PACKAGE', PACKAGE)
    define('PACKAGE_NAME', APPNAME)
    define('PACKAGE_STRING', '%s %s' % (APPNAME, VERSION))
    define('PACKAGE_TARNAME', PACKAGE)

    define('INSTALL_PREFIX', conf.escpath(sub('${PREFIX}/', env)))
    #dfn('LT_OBJDIR', '.libs') - what's the purpose?
    define('PACKAGE_BUGREPORT','https://github.com/crosswire/xiphos/issues' )
    define('PACKAGE_DATA_DIR', conf.escpath(sub('${DATAROOTDIR}/${PACKAGE}', env)))
    define('PACKAGE_DOC_DIR', conf.escpath(env['DOCDIR']))
    define('PACKAGE_HELP_DIR', conf.escpath(sub('${DATAROOTDIR}/gnome/help/${PACKAGE}', env)))
    define('PACKAGE_LOCALE_DIR', conf.escpath(env['LOCALEDIR']))
    define('PACKAGE_MENU_DIR', conf.escpath(sub('${DATAROOTDIR}/applications', env)))
    #define('PACKAGE_PIXMAPS_DIR', conf.escpath(sub('${DATAROOTDIR}/pixmaps/${PACKAGE}', env)))
    define('PACKAGE_PIXMAPS_DIR', conf.escpath(sub('${DATAROOTDIR}/${PACKAGE}', env)))
    define('PACKAGE_SOURCE_DIR', conf.escpath(os.path.abspath(srcdir))) # folder where was wscript executed
    if not env["IS_WIN32"]:
        # for installing xiphos.appdata.xml
        define('PACKAGE_APPDATA_DIR', conf.escpath(sub('${INSTALL_PREFIX}/share/appdata', env)))

    common_libs = string.join(
    '''
    "gconf-2.0"
    "gmodule-2.0"
    "glib-2.0"
    "libgsf-1 >= 1.14"
    "libxml-2.0"
    --cflags --libs'''
    .split()," ")

    if env['ENABLE_GTK2']:
        env.append_value('ALL_LIBS', 'LIBGLADE')
        # We need to know specific versions of GTK+-2.0
        common_libs += ' libglade-2.0'
        common_libs += ' webkit-1.0'
        if opt.webkit_editor:
            conf.define('USE_WEBKIT_EDITOR', 1)
            env['ENABLE_WEBKIT_EDITOR'] = True
            common_libs += ' "gtk+-2.0 >= 2.24" '
        elif conf.check_cfg(modversion='gtkhtml-editor-3.14',
                          msg='Checking for GNOME3 gtkhtml-editor',
                          okmsg='Definitely',
                          errmsg='Probably not',
                          mandatory=True
                          ):
            common_libs += ' "gtk+-2.0 >= 2.14" '
            common_libs += ' "gtkhtml-editor-3.14" '
            common_libs += ' "libgtkhtml-3.14 >= 3.23" '
    else:
        common_libs += ' "gtk+-3.0" '
        conf.define('USE_GTK_3', 1)
        conf.define('USE_GTKBUILDER', 1)
        if opt.webkit_editor:
            conf.define('USE_WEBKIT_EDITOR', 1)
            env['ENABLE_WEBKIT_EDITOR'] = True
            common_libs += ' "webkitgtk-3.0" '
        else:
            if conf.check_cfg(modversion='libgtkhtml-4.0',

=== debian/changelog ===
xiphos (4.1.0.1+dfsg1-1) unstable; urgency=medium

  * fix hash size mismatch on upload
  * thanks to Yavor Doganov for the gconf patch: Closes: #912807

 -- Teus Benschop <teusjannette@gmail.com>  Mon, 03 Dec 2018 15:43:40 +0100

xiphos (4.1.0+dfsg1-3) unstable; urgency=high

  * thanks to Yavor Doganov for the gconf patch: Closes: #912807
  * d/control: drop dependency libgconf2
  * d/patches: remove gconf-2 from source

 -- Teus Benschop <teusjannette@gmail.com>  Sat, 17 Nov 2018 18:12:02 +0100

xiphos (4.1.0+dfsg1-2) unstable; urgency=medium

  * d/patches: reorganize

 -- Teus Benschop <teusjannette@gmail.com>  Sat, 17 Nov 2018 16:42:43 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,6 @@
                intltool,
                libbiblesync-dev,
                libdbus-glib-1-dev,
-               libgconf2-dev,
                libgsf-1-dev,
                libgtk-3-dev,
                libsword-dev (>= 1.8.1+dfsg-8),

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,7 @@
 	dh_installchangelogs ChangeLog
 
 override_dh_missing:
-	dh_missing --list-missing
+	dh_missing --fail-missing
 
 override_dh_strip:
 	dh_strip --dbgsym-migration='xiphos-dbg (<< 4.0.5+dfsg1-1~)'

=== debian/watch ===
version=3
# No repacksuffix is specified because it's handled by debian/repack-waf.
# See <https://wiki.debian.org/UnpackWaf>.
opts=dversionmangle=s/\+dfsg\d+$// \
https://github.com/crosswire/xiphos/releases/ .*/xiphos-([\d\.]+)(?:-[\d]+)?\.tar\.gz debian debian/repack-waf

## xiphos 4.2.1%2Bdfsg1

=== CMakeLists.txt ===
# Xiphos build script
#
# Copyright (C) 2018 Xiphos Development Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
#

# the oldest stable cmake version we support
cmake_minimum_required (VERSION 3.11 FATAL_ERROR)
cmake_policy(VERSION 3.11)

### set project name (version set later)
project (xiphos C CXX)

# set commonly used Xiphos variables:
# Xiphos website
set (XIPHOS_WEBSITE "http://xiphos.org")

# Xiphos issues report website
set (XIPHOS_BUG_REPORT "https://github.com/crosswire/xiphos/issues")

# Xiphos release date, (read from 'ChangeLog')
# read last entry in ChangeLog
file(STRINGS ${PROJECT_SOURCE_DIR}/ChangeLog
  ChangeLog_lastentry REGEX "^20[0-9][0-9]-[0-9][0-9]" LIMIT_COUNT 1)
# get year
string(SUBSTRING ${ChangeLog_lastentry} 0 4 ChangeLog_year)
# get month's number
string(SUBSTRING ${ChangeLog_lastentry} 5 2 ChangeLog_month)
# transform month's number into month's name
list(APPEND month_names "XXX;Jan;Feb;Mar;Apr;May;Jun;Jul;Aug;Sep;Oct;Nov;Dec")
list(GET month_names ${ChangeLog_month} ChangeLog_month)
# generate release date string
string(CONFIGURE "@ChangeLog_month@ @ChangeLog_year@" XIPHOS_RELEASE_DATE)


# make sure it's an out-of-stream build
file(TO_CMAKE_PATH "${PROJECT_BINARY_DIR}/CMakeLists.txt" LOC_PATH)
if(EXISTS "${LOC_PATH}")
  message(FATAL_ERROR "You cannot build in the source directory (or any directory with a CMakeLists.txt file). Please make an out-of-stream build subdirectory.")
endif()


# tell cmake where its modules can be found in our project directory
list (APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
list (APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)

# parse the current version based on git tags, then cache a result on behalf
# of source tarballs that don't have the repo .git metadata
set(SOURCE_VERSION_CACHE "${PROJECT_SOURCE_DIR}/cmake/source_version.txt")
if(EXISTS "${PROJECT_SOURCE_DIR}/.git")
	include(GetGitRevisionDescription)
	git_describe(GIT_VERSION --tags)
	string(REGEX REPLACE "-([0-9]*).*" ".\\1" VERSION "${GIT_VERSION}")
	file(WRITE ${SOURCE_VERSION_CACHE} "${VERSION}")
else()
	file(STRINGS ${SOURCE_VERSION_CACHE} VERSION)
endif()

# configure project name and version
project (xiphos
	VERSION "${VERSION}")

# set install directory variables as defined by the GNU Coding Standards.
# e.g. CMAKE_INSTALL_DATAROOTDIR; CMAKE_INSTALL_FULL_BINDIR;
# CMAKE_INSTALL_FULL_DOCDIR...
include (GNUInstallDirs)

# set CMAKE options that the user can optionally select ON or OFF.
include (XiphosOptions)

# find needed tools for building Xiphos
include (XiphosBuildTools)

# find dependencies
include (XiphosDependencies)

# set flags
include (XiphosFlags)

# create config.h
include (XiphosConfig_h)

# build xiphos
add_subdirectory(win32)
add_subdirectory(src/backend)
add_subdirectory(src/editor)
add_subdirectory(src/main)
add_subdirectory(src/webkit)
add_subdirectory(src/xiphos_html)
add_subdirectory(src/gtk)

# build xiphos-nav
add_subdirectory(src/examples)

# build other stuff
add_subdirectory(pixmaps)
add_subdirectory(ui)
add_subdirectory(po)
add_subdirectory(desktop)
add_subdirectory(doc)
add_subdirectory(help)

# create packages
add_subdirectory(cpack)

# report
include (XiphosReport)
# End

=== ui/CMakeLists.txt ===
# Xiphos build script
#
# Copyright (C) 2018 Xiphos Development Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
#

# install ui files
if (NOT GTK2)
  # Gtk3 only stuff
  install (FILES
    bookmarks.gtkbuilder
    bookmarks_old.gtkbuilder
    editor_link_dialog.gtkbuilder
    editor_link_dialog_old.gtkbuilder
    export-dialog.gtkbuilder
    export-dialog_old.gtkbuilder
    markverse.gtkbuilder
    markverse_old.gtkbuilder
    module-manager.gtkbuilder
    module-manager_old.gtkbuilder
    navbar_versekey.gtkbuilder
    navbar_versekey_old.gtkbuilder
    prefs.gtkbuilder
    prefs_old.gtkbuilder
    search-dialog.gtkbuilder
    search-dialog_old.gtkbuilder
    selector-prefs.gtkbuilder
    selector-prefs_old.gtkbuilder
    xi-menus.gtkbuilder
    xi-menus_old.gtkbuilder
    xi-menus-popup.gtkbuilder
    xi-menus-popup_old.gtkbuilder
    xi-splash.gtkbuilder
    xi-splash_old.gtkbuilder
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}
    COMPONENT data
    )
else  (NOT GTK2)
  # Gtk2 only stuff
  install (FILES
    bookmarks.glade
    editor_link_dialog.glade
    export-dialog.glade
    markverse.glade
    module-manager.glade
    navbar_versekey.glade
    prefs.glade
    search-dialog.glade
    selector-prefs.glade
    xi-export-bookmarks.glade
    xi-menus.glade
    gtk2_webedit.ui
    gtk_webedit.ui
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}
    COMPONENT data
    )
endif (NOT GTK2)

# common stuff
install (FILES
  editor_note.xml
  editor_studypad.xml
  arrow_down_box.png
  arrow_down.png
  arrow_up_box.png
  arrow_up.png
  biblesync-v1-30.png
  biblesync-v1-50.png
  biblesync_icon-16.png
  chat_icon-16.png
  dlg-un-16.png
  epiphany-bookmarks.png
  gnome-session.png
  gnome-sound-properties.png
  gnome-windows.png
  logo.png
  mailing_list_icon-16.png
  new_tab_button.png
  silk-edit-bookmarks.png
  sword3.png
  sword_icon-16.png
  sword.png
  translation_icon-16.png
  xiphos-x-16.png
  languages
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}
  COMPONENT data
  )

=== src/backend/CMakeLists.txt ===
# Xiphos build script
#
# Copyright (C) 2018 Xiphos Development Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
#

# build backend

add_library (backend STATIC
  gs_stringmgr.cpp
  module_manager.cc
  sword_main.cc
  )
# Add alias
add_library(Xiphos::Backend ALIAS backend)


# specify include directories to use when compiling
target_include_directories(backend
  PRIVATE
  Threads::Threads
  PkgConfig::Core
  PkgConfig::Gtk
  PkgConfig::Gnome
  PkgConfig::Sword

  )

# specify libraries or flags to use when linking
target_link_libraries(backend
  PRIVATE
  Threads::Threads
  PkgConfig::Core
  PkgConfig::Gtk
  PkgConfig::Gnome
  PkgConfig::Sword
  )

=== src/webkit/CMakeLists.txt ===
# Xiphos build script
#
# Copyright (C) 2018 Xiphos Development Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
#

# building webkit

# marshalling
add_custom_command (
  OUTPUT
  ${CMAKE_CURRENT_BINARY_DIR}/marshal.h
  ${CMAKE_CURRENT_BINARY_DIR}/marshal.c
  # Marshalling
  COMMAND ${GLIB_GENMARSHAL}
  ${CMAKE_CURRENT_SOURCE_DIR}/marshal.list
  --prefix=wk_marshal
  --header > ${CMAKE_CURRENT_BINARY_DIR}/marshal.h

  COMMAND ${GLIB_GENMARSHAL}
  ${CMAKE_CURRENT_SOURCE_DIR}/marshal.list
  --prefix=wk_marshal
  --body > ${CMAKE_CURRENT_BINARY_DIR}/marshal.c

  MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/marshal.list
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Marshalling webkit files"
  )


# build
add_library (webkit
  STATIC
  wk-html.c
  wk-html.h
  ${CMAKE_CURRENT_BINARY_DIR}/marshal.c
  )

# Add alias
add_library(Xiphos::Webkit ALIAS webkit)


# specify include directories to use when compiling
target_include_directories(webkit
  PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR} # for marshal.h
  Threads::Threads
  PkgConfig::Core
  PkgConfig::Gtk
  PkgConfig::Gnome
  )

# specify libraries or flags to use when linking
target_link_libraries(webkit
  PRIVATE
  Threads::Threads
  PkgConfig::Core
  PkgConfig::Gtk
  PkgConfig::Gnome
  )

=== src/xiphos_html/CMakeLists.txt ===
# Xiphos build script
#
# Copyright (C) 2018 Xiphos Development Team
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
#

# building xiphos_html

# marshalling
add_custom_command (
  OUTPUT
  ${CMAKE_CURRENT_BINARY_DIR}/marshal.h
  ${CMAKE_CURRENT_BINARY_DIR}/marshal.c
  # Marshalling
  COMMAND ${GLIB_GENMARSHAL}
  ${CMAKE_CURRENT_SOURCE_DIR}/marshal.list
  --prefix=xihtml_marshal
  --header > ${CMAKE_CURRENT_BINARY_DIR}//marshal.h

  COMMAND ${GLIB_GENMARSHAL}
  ${CMAKE_CURRENT_SOURCE_DIR}/marshal.list
  --prefix=xihtml_marshal
  --body > ${CMAKE_CURRENT_BINARY_DIR}/marshal.c

  MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/marshal.list
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Marshalling xiphos_html files"
  )


# build
add_library (xiphos_html
  STATIC
  xiphos_html.c
  xiphos_html.h
  ${CMAKE_CURRENT_BINARY_DIR}/marshal.c
  )

# Add alias
add_library(Xiphos::Xiphos_html ALIAS xiphos_html)

# specify include directories to use when compiling
target_include_directories(xiphos_html
  PRIVATE
  Threads::Threads
  PkgConfig::Core
  PkgConfig::Gtk
  PkgConfig::Gnome
  )

# specify libraries or flags to use when linking
target_link_libraries(xiphos_html
  PRIVATE
  Threads::Threads
  PkgConfig::Core
  PkgConfig::Gtk
  PkgConfig::Gnome
  )
